#include "stdafx.h"
#include "m2fz.h"

// CM2fz
CM2fz::CM2fz()
{
	Load();
}

CM2fz::~CM2fz()
{
	Unload();
}

// CM2fz o֐
void CM2fz::Load(void)
{
	LPCTSTR lpszName = _T("mgc2fz.dll");

	m_hMFZ = LoadLibrary(lpszName);

	if(m_hMFZ != NULL) 
	{
		mfzInitialize			= (LPINITIALIZE)GetProcAddress(m_hMFZ, "mfzInitialize");

		mfzVerifyProductKey		= (LPVERIFYPRODUCTKEY)GetProcAddress(m_hMFZ, "mfzVerifyProductKey"); 
		mfzVerifyValidationCode	= (LPVERIFYVALIDATIONCODE)GetProcAddress(m_hMFZ, "mfzVerifyValidationCode"); 
		mfzGetValidationCode	= (LPGETVALIDATIONCODE)GetProcAddress(m_hMFZ, "mfzGetValidationCode");

		mfzGetTime				= (LPGETTIME)GetProcAddress(m_hMFZ, "mfzGetTime");
		mfzGetTimeSpan			= (LPGETTIMESPAN)GetProcAddress(m_hMFZ, "mfzGetTimeSpan");
		mfzGetSystemTime		= (LPGETSYSTEMTIME)GetProcAddress(m_hMFZ, "mfzGetSystemTime");

		mfzGetTrunkName			= (LPGETTRUNKNAME)GetProcAddress(m_hMFZ, "mfzGetTrunkName");
		mfzCreateTrunk			= (LPCREATETRUNK)GetProcAddress(m_hMFZ, "mfzCreateTrunk");
		mfzGetCode				= (LPGETCODE)GetProcAddress(m_hMFZ, "mfzGetCode");
		mfzPutCode				= (LPPUTCODE)GetProcAddress(m_hMFZ, "mfzPutCode");

		mfzShowInputBox			= (LPSHOWINPUTBOX)GetProcAddress(m_hMFZ, "mfzShowInputBox");
		mfzGetFileVersion		= (LPGETFILEVERSION)GetProcAddress(m_hMFZ, "mfzGetFileVersion");

		//
		//// ffiKvȂύXj
		//
		DWORD dwMajor = 0;
		DWORD dwMinor = 0;
		
		if(		mfzGetFileVersion(CT2W(lpszName), &dwMajor, &dwMinor, NULL, NULL) != SUCCESS
			||  !(dwMajor == 2 && dwMinor >= 1600)	)
		{
			Unload();
		}
	}
}

void CM2fz::Unload(void)
{
	if(m_hMFZ != NULL) 
	{
		BOOL bR = FreeLibrary(m_hMFZ);
		m_hMFZ = NULL;
	}
}

int CM2fz::AreYouReady(void)
{
	return (m_hMFZ != NULL)? YES : NO;
}
