#pragma once
#include <Msiquery.h>

//	CM2fz R}h ^[Qbg
//	Ver1.1402c
class CM2fz : public CObject
{
public:
	CM2fz();
	virtual ~CM2fz();

public:

	static const INT YES		= TRUE;
	static const INT NO			= FALSE;
	static const INT SUCCESS	= 0;
	static const INT FAILURE	= -1;
	
	static const INT ID_KV40_SIZE		= 192;			// hcTCY(oCg) v_NgL[o[W 4.0
	static const INT ID_KV41_SIZE		= ID_KV40_SIZE;	// hcTCY(oCg) v_NgL[o[W 4.1
	static const INT PRODUCTKEY_SIZE	= 19;			// v_NgL[pobt@TCY(oCg)
	static const INT PRODUCTKEY_18		= 18;			// v_NgL[PW
	static const INT PRODUCTKEY_16		= 16;			// v_NgL[PU
	static const INT VALDATIONCODE_SIZE	= 24;			// F؃R[h̃TCY(oCg)
	static const INT TIME_SIZE			= 16;			// Ԓl̃TCY(oCg)
	static const INT USER_NAME_SIZE		= 17;			// [U[̃TCY
	static const INT USER_NAME_MIN_SIZE	= 4;			// [U[̍ŏTCY

	//
	//// mfzInitialize
	//

	// 
	static const INT INI_PARAMS_A_SIZE	= 200;
	static const INT INI_PARAMS_B_SIZE	= 28;

	static const ULONG INI_PRODUCTKEY_VERSION			= 0x0000ffff;
	static const ULONG INI_PRODUCTKEY_OPTIONS			= 0xffff0000;
	static const ULONG INI_TIME_FORMAT					= 0x000f0000;
	static const ULONG INI_VALDATIONCODE				= 0x00f00000;
	static const ULONG INI_PRODUCTKEY_VERSION_40		= 40;
	static const ULONG INI_PRODUCTKEY_VERSION_41		= 41;
	static const ULONG INI_TIME_FORMAT_A				= 0x00000000;
	static const ULONG INI_TIME_FORMAT_B				= 0x00010000;
	static const ULONG INI_TIME_FORMAT_C				= 0x00020000;
	static const ULONG INI_VALDATIONCODE_HDD			= 0x00000000;	// F؃R[h쐬ɂgcctH[}bgio[܂߂
	static const ULONG INI_VALDATIONCODE_CPU			= 0x00100000;	// F؃R[h쐬ɂbot̎ނ܂߂
	static const ULONG INI_VALDATIONCODE_HDD_AND_CPU	= 0x00200000;	// INI_VALDATIONCODE_HDD + INI_VALDATIONCODE_CPU
	
	static const ULONG INI_STANDARD	= INI_PRODUCTKEY_VERSION_41 | INI_TIME_FORMAT_C;
	static const ULONG INI_LEGACY	= INI_PRODUCTKEY_VERSION_41 | INI_TIME_FORMAT_B;
			
	// ߂l
	static const INT INI_ERR_INITIAL_STATE	=  4000;
	static const INT INI_ERR_RESOURCE_CRC	= -4000;
	static const INT INI_ERR_RESOURCE		= -4001;
	static const INT INI_ERR_FILE			= -4002;
	static const INT INI_ERR_DLL_VERSION	= -4003;
		
	// \
	typedef struct 
	{
		ULONG	nSize;						// ̍\̂̃TCY
		ULONG	nFunctions;					// v_NgL[̃o[W
		BYTE	szIdentity[ID_KV41_SIZE];	// AvP[Vhc
	} INI_PARAMS_A, *LPINI_PARAMS_A;

	typedef struct 
	{
		ULONG		nSize;			// ̍\̂̃TCY
		ULONG		nFunctions;		// v_NgL[̃o[W
		ULONG		nMagicCode;		// ckkɃANZX邽߂̎ʔԍ
		SYSTEMTIME	sysBeginningDate;		// ckkɂhc񂾎
	} INI_PARAMS_B, *LPINI_PARAMS_B;

	
	//
	//// mfzGetTimeSpan & mfzGetSystemTime
	//

	// ߂l
	static const INT TMS_INVALID_TIME			= -4100;
	static const INT TMS_SUCCESS_AND_TIME_MADE	=  4100;

	//
	// mfzGetCode & mfzPutCode
	//

	// ߂l
	static const INT COD_ERR_INITIAL_STATE		=  4200;
	static const INT COD_ERR_LOAD				= -4200;
	static const INT COD_ERR_CRC				= -4201;
	static const INT COD_ERR_NO_TRUNK			= -4202;
	static const INT COD_ERR_RESOURCE			= -4203;
	static const INT COD_ERR_FILE				= -4204;
	static const INT COD_ERR_FILE_NOT_FOUND		= -4205;
	static const INT COD_ERR_INVALID_FILE_NAME	= -4206;

	//
	//// mfzCreateTrunk
	//
	static const DWORD CTK_ATTRIBUTE_NORMAL		= 0x00000080;
	static const DWORD CTK_ATTRIBUTE_READONLY	= 0x00000001;
	static const DWORD CTK_ATTRIBUTE_HIDDEN		= 0x00000002;

	// ߂l
	static const INT CTK_ERR_CRC		= COD_ERR_CRC; 
	static const INT CTK_ERR_FILE		= COD_ERR_FILE;
	static const INT CTK_ERR_RESOURCE	= COD_ERR_RESOURCE;

	//
	//// GetTrunkName
	//
	static const ULONG GTN_COMMAND					= 0x000000ff;
	static const ULONG GTN_OPTIONS					= 0xffffff00;
	static const ULONG GTN_GET_APPDATA_PATH			= 0x00000000;	// Common App path 擾
	static const ULONG GTN_GET_TRUNK_PATH			= 0x00000001;	// Trunk file path 擾
	static const ULONG GTN_GET_TRUNK_PATH_AND_NAME	= 0x00000002;	// Trunk file name and path 擾
	static const ULONG GTN_GET_TRUNK_NAME			= 0x00000003;	// Trunk file name 擾
	static const ULONG GTN_MAKE_DIRECTORY			= 0x00000100;	// fBNg쐬

	static const INT GTN_CHAR_SIZE					= 32;

	//
	//// mfzShowInputBox
	//

	// ߂l
	static const INT SIB_OK		= 0;
	static const INT SIB_CANCEL	= 2;


	//
	////  ֐`
	//
	typedef int (CALLBACK* LPINITIALIZE)			(	const LPVOID lpInitialParams	);

	typedef int	(CALLBACK* LPVERIFYPRODUCTKEY)		(	const	LPSTR lpszProductKey	);
	typedef int	(CALLBACK* LPVERIFYVALIDATIONCODE)	(	const	LPSTR lpszUserName, 
																LPBYTE lpszValidationCode	);
	typedef int (CALLBACK* LPGETVALIDATIONCODE)		(	const	LPSTR lpszProductKey, 
														const	LPSTR lpszUserName, 
																LPBYTE lpszValidationCode	);

	typedef int (CALLBACK* LPGETTIME)		(	const	LPSTR lpszUserName, 
														LPBYTE lpszTime	);
	typedef int (CALLBACK* LPGETTIMESPAN)	(	const	LPSTR lpszUserName, 
												const	LPBYTE lpszTime	);
	typedef int (CALLBACK* LPGETSYSTEMTIME)	(	const	LPSTR		lpszUserName, 
												const	LPBYTE		lpszTime, 
														SYSTEMTIME* lpsysTime	);

	typedef int (CALLBACK* LPGETTRUNKNAME)	(	const	ULONG	nFunction, 
														LPCSTR	lpszManufacturer, 
														LPCSTR	lpszProductName,
												const	int		nSize, 
														LPWSTR	lpszResult	);
	typedef int (CALLBACK* LPCREATETRUNK)	(			LPCWSTR	lpszFileName,
												const	DWORD	dwAttributes	);
	typedef int (CALLBACK* LPGETCODE)		(			LPCWSTR	lpszFileName, 
														LPBYTE	lpszValidationCode, 
														LPBYTE	lpszTime, 
														LPSTR	lpszUserName	);
	typedef int (CALLBACK* LPPUTCODE)		(			LPCWSTR	lpszFileName, 
												const	LPBYTE	lpszValidationCode, 
												const	LPBYTE	lpszTime, 
												const	LPSTR	lpszUserName	);

	typedef UINT (CALLBACK* LPUNINSTALL_1A)			(MSIHANDLE hInstall);
	typedef UINT (CALLBACK* LPCUSTOMERINFOFORM_1A)	(MSIHANDLE hInstall);

	typedef int  (CALLBACK* LPSHOWINPUTBOX)	(			LPCWSTR	lpszTitle, 
														LPCWSTR	lpszMsg, 
												const	int		nFigure, 
														LPSTR	lpszUserName, 
														LPSTR	lpszProductKey	);
	typedef	int  (CALLBACK* LPGETFILEVERSION)(	LPCWSTR  lpszFile, 
												DWORD*	lpdwMajor, 
												DWORD*	lpdwMinor, 
												DWORD*	lpdwRevision,
												DWORD*	lpdwBild	);

	
	LPINITIALIZE			mfzInitialize;

	LPVERIFYPRODUCTKEY		mfzVerifyProductKey;
	LPVERIFYVALIDATIONCODE	mfzVerifyValidationCode;
	LPGETVALIDATIONCODE		mfzGetValidationCode;

	LPGETTIME				mfzGetTime;
	LPGETTIMESPAN			mfzGetTimeSpan;
	LPGETSYSTEMTIME			mfzGetSystemTime;

	LPGETTRUNKNAME			mfzGetTrunkName;
	LPCREATETRUNK			mfzCreateTrunk;
	LPGETCODE				mfzGetCode;
	LPPUTCODE				mfzPutCode;
	
	LPUNINSTALL_1A			mfzUninstall_1a;
	LPCUSTOMERINFOFORM_1A	mfzCustomerInfoForm_1a;

	
	LPSHOWINPUTBOX			mfzShowInputBox;
	LPGETFILEVERSION		mfzGetFileVersion;


	void Load(void);
	void Unload(void);
	int	 AreYouReady(void);

private:
	HMODULE m_hMFZ;
};