////
////////	mgc2fz.dll Ver2.1600a Header
////
#pragma once

	#define MFZ_TRUE		TRUE
	#define MFZ_FALSE		FALSE
	#define MFZ_YES			TRUE
	#define MFZ_NO			FALSE
	#define MFZ_NULL		NULL
	#define MFZ_SUCCESS		0
	#define MFZ_FAILURE		-1
	#define MFZ_MAX_PATH	MAX_PATH
	
	#define MFZ_ID_KV40_SIZE		192					// hcTCY(oCg) v_NgL[o[W 4.0
	#define MFZ_ID_KV41_SIZE		MFZ_ID_KV40_SIZE	// hcTCY(oCg) v_NgL[o[W 4.1
	#define MFZ_PRODUCTKEY_SIZE		19					// v_NgL[pobt@TCY(oCg)
	#define MFZ_PRODUCTKEY_18		18					// v_NgL[PW
	#define MFZ_PRODUCTKEY_16		16					// v_NgL[PU
	#define MFZ_VALDATIONCODE_SIZE	24					// F؃R[h̃TCY(oCg)
	#define MFZ_TIME_SIZE			16					// Ԓl̃TCY(oCg)
	#define MFZ_USER_NAME_SIZE		17					// [U[̃TCY
	#define MFZ_USER_NAME_MIN_SIZE	4					// [U[̍ŏTCY

	//
	//// mfzInitialize
	//

	// 
	#define MFZ_INI_PARAMS_A_SIZE	200
	#define MFZ_INI_PARAMS_B_SIZE	28

	#define MFZ_INI_PRODUCTKEY_VERSION			0x0000ffff
	#define MFZ_INI_PRODUCTKEY_OPTIONS			0xffff0000
	#define MFZ_INI_TIME_FORMAT					0x000f0000
	#define MFZ_INI_VALDATIONCODE				0x00f00000
	#define MFZ_INI_PRODUCTKEY_VERSION_40		40
	#define MFZ_INI_PRODUCTKEY_VERSION_41		41
	#define MFZ_INI_TIME_FORMAT_A				0x00000000
	#define MFZ_INI_TIME_FORMAT_B				0x00010000
	#define MFZ_INI_TIME_FORMAT_C				0x00020000
	#define MFZ_INI_VALDATIONCODE_HDD			0x00000000	// F؃R[h쐬ɂgcctH[}bgio[܂߂
	#define MFZ_INI_VALDATIONCODE_CPU			0x00100000	// F؃R[h쐬ɂbot̎ނ܂߂
	#define MFZ_INI_VALDATIONCODE_HDD_AND_CPU	0x00200000	// MFZ_INI_VALDATIONCODE_HDD + MFZ_INI_VALDATIONCODE_CPU

	#define MFZ_INI_STANDARD	MFZ_INI_PRODUCTKEY_VERSION_41 | MFZ_INI_TIME_FORMAT_C
	#define MFZ_INI_LEGACY		MFZ_INI_PRODUCTKEY_VERSION_41 | MFZ_INI_TIME_FORMAT_B
			
	// ߂l
	#define MFZ_INI_ERR_INITIAL_STATE	 4000
	#define MFZ_INI_ERR_RESOURCE_CRC	-4000
	#define MFZ_INI_ERR_RESOURCE		-4001
	#define MFZ_INI_ERR_FILE			-4002
	#define MFZ_INI_ERR_APPID_VERSION	-4003	// ̃o[Ŵleyɂ͏݋֎~
		
	// \
	typedef struct 
	{
		ULONG	nSize;							// ̍\̂̃TCY
		ULONG	nFunctions;						// v_NgL[̃o[W
		BYTE	szIdentity[MFZ_ID_KV41_SIZE];	// AvP[Vhc
	} MFZ_INI_PARAMS_A, *LPMFZ_INI_PARAMS_A;

	typedef struct 
	{
		ULONG		nSize;		// ̍\̂̃TCY
		ULONG		nFunctions;	// v_NgL[̃o[W
		ULONG		nMagicCode;	// ckkɃANZX邽߂̎ʔԍ
		SYSTEMTIME	sysPutTime;	// ckkɂhc񂾎
	} MFZ_INI_PARAMS_B, *LPMFZ_INI_PARAMS_B;
	
	//
	//// mfzGetTimeSpan & mfzGetSystemTime
	//

	// ߂l
	#define MFZ_TMS_INVALID_TIME					-4100
	#define MFZ_TMS_SUCCESS_AND_TIME_MADE			 4100

	//
	// mfzGetCode & mfzPutCode
	//

	// ߂l
	#define MFZ_COD_ERR_INITIAL_STATE				 4200
	#define MFZ_COD_ERR_LOAD						-4200
	#define MFZ_COD_ERR_CRC							-4201
	#define MFZ_COD_ERR_NO_TRUNK					-4202
	#define MFZ_COD_ERR_RESOURCE					-4203
	#define MFZ_COD_ERR_FILE						-4204
	#define MFZ_COD_ERR_FILE_NOT_FOUND				-4205
	#define MFZ_COD_ERR_INVALID_FILE_NAME			-4206

	//
	//// mfzCreateTrunk
	//
	#define MFZ_CTK_ATTRIBUTE_NORMAL	0x00000080
	#define MFZ_CTK_ATTRIBUTE_READONLY	0x00000001
	#define MFZ_CTK_ATTRIBUTE_HIDDEN	0x00000002

	// ߂l
	#define MFZ_CTK_ERR_CRC			MFZ_COD_ERR_CRC 
	#define MFZ_CTK_ERR_FILE		MFZ_COD_ERR_FILE
	#define MFZ_CTK_ERR_RESOURCE	MFZ_COD_ERR_RESOURCE

	//
	//// GetTrunkName
	//
	#define MFZ_GTN_COMMAND						0x000000ff
	#define MFZ_GTN_OPTIONS						0xffffff00
	#define MFZ_GTN_GET_APPDATA_PATH			0x00000000	// Common App path 擾
	#define MFZ_GTN_GET_TRUNK_PATH				0x00000001	// Trunk file path 擾
	#define MFZ_GTN_GET_TRUNK_PATH_AND_NAME		0x00000002	// Trunk file name and path 擾
	#define MFZ_GTN_GET_TRUNK_NAME				0x00000003	// Trunk file name 擾
	#define MFZ_GTN_MAKE_DIRECTORY				0x00000100	// fBNg쐬

	#define MFZ_GTN_CHAR_SIZE					32

	//
	//// mfzShowInputBox
	//

	// ߂l
	#define MFZ_SIB_OK		0
	#define MFZ_SIB_CANCEL	2
