Imports System.Text
Imports TestFZ.m2fz

Module Main

    Public Sub Main()

        Try
            '// mfz dll Load
            Load()
            '// mfz dll `FbN
            If (AreYouReady() <> MFZ_YES) Then
                MessageBox.Show("This program has not loaded FZ DLL.")
                Application.Exit()
                Return
            End If


            '// Give the commnd.
            '// vWFNg[vpeB][fobO]<R}hC>"/a"ݒł
            Dim command() As String = Environment.GetCommandLineArgs()
            Dim strategy() As String = New String() {"/a", "/b", "/c", "/d", ""}
            Dim n As Integer
            Dim r As Boolean

            For n = 4 To -1 Step -1

                If (command.GetUpperBound(0) = 0) Then
                    Exit For
                Else
                    If command(1) = strategy(n) Then
                        Exit For
                    End If
                End If
            Next

            If n = 4 Then
                Dim dlg As Headquarters = New Headquarters()

                dlg.ShowDialog()
                n = dlg.GetStrategy()

                dlg.Dispose()
            End If

            Select Case n
                Case 0
                    r = ExecuteStrategyA(strategy(n))
                Case 1
                    r = ExecuteStrategyB(strategy(n))
	            Case 2
                    r = ExecuteStrategyC(strategy(n))
	            Case 3
                    r = ExecuteStrategyD(strategy(n))
                Case Else
                    r = False
            End Select

            '// mfz dll unload
            UnLoad()

            If (r) Then
                Dim form As New Form1
                form.ShowDialog()
            Else
                MessageBox.Show("The unrecognized code will terminate this program" + _
                                " about 10 seconds after.")
                Return
            End If

        Catch e As Exception

            MessageBox.Show(e.Message)
            Return

        End Try

    End Sub

    Private Sub ShowConditions(ByVal command As String, _
                                ByVal magicCode As Integer, _
                                ByVal installer As Integer, _
                                ByVal hardware As Integer)

        Dim n1 As Integer
        Dim n2 As Integer
        Dim id() As String = New String() {"Outside", "Inside"}
        Dim isInstallerUsing() As String = New String() {"NO", "YES"}
        Dim includingHardware() As String = New String() {"HDD", "CPU", "HDD and CPU"}

        If magicCode = 0 Then
            n1 = 0
        Else
            n1 = 1
        End If

        If hardware = MFZ_VALDATIONCODE_HDD_AND_CPU Then
            n2 = 2
        ElseIf hardware = MFZ_VALDATIONCODE_CPU Then
            n2 = 1
        Else
            n2 = 0
        End If

        MessageBox.Show(String.Format("Command line : {0:s}" + vbCr + _
                                      "Identity : {1:s}(0x{2:x})" + vbCr + _
                                      "Installer : {3:s}" + vbCr + _
                                      "Validation Code : {4:s}", _
                                      command, _
                                      id(n1), _
                                      magicCode, _
                                      isInstallerUsing(installer), _
                                      includingHardware(n2)), _
                                      "Conditions")

    End Sub

    Private Function Verify() As Boolean

        '//
        '//// ě
        '//

        '// Trunk t@C쐬
        Dim manufacturer As String = New String("", MFZ_GTN_CHAR_SIZE)
        Dim productName As String = New String("", MFZ_GTN_CHAR_SIZE)
        Dim trunkName As StringBuilder = New StringBuilder("", MFZ_MAX_PATH)


        manufacturer = "m.magic" '// CXg[[ŎgpO
        productName = "TestFZ"   '// CXg[[ŎgpO

        mfzGetTrunkName(MFZ_GTN_GET_TRUNK_PATH_AND_NAME Or MFZ_GTN_MAKE_DIRECTORY, _
                        manufacturer, _
                        productName, _
                        MFZ_MAX_PATH, _
                        trunkName)


        '// Trunk t@CF؃R[hǂ
        Dim createTrunk As Boolean = False
        Dim getTime As Boolean = False
        Dim putData As Boolean = False
        Dim verifyCode As Boolean = True
        Dim time() As Byte : ReDim time(MFZ_TIME_SIZE)
        Dim validationCode() As Byte : ReDim validationCode(MFZ_VALDATIONCODE_SIZE)
        Dim userName As StringBuilder = New StringBuilder("", MFZ_USER_NAME_SIZE)
        Dim r0 As Integer


        createTrunk = getTime = putData = False
        verifyCode = True

        r0 = mfzGetCode(trunkName.ToString(), validationCode, time, userName)

        If (r0 = MFZ_COD_ERR_FILE_NOT_FOUND) Then
            userName.Append(" ")    '// Xy[XƃOCɂȂ
            getTime = True
            putData = True
            createTrunk = True
            verifyCode = False
        ElseIf (r0 = MFZ_COD_ERR_INITIAL_STATE) Then
            userName.Append(" ")   '// Xy[XƃOCɂȂ
            getTime = putData = True
            verifyCode = False
        End If

        '// F؃R[h̐ff
        Dim produktKey As StringBuilder = New StringBuilder("", MFZ_PRODUCTKEY_SIZE)
        Dim ok As Integer = MFZ_NO
        Dim productKeySize As Integer = MFZ_PRODUCTKEY_16

        If (verifyCode) Then
            ok = mfzVerifyValidationCode(userName.ToString(), validationCode)
        End If

        If (ok = MFZ_NO) Then
            '// L[͂`FbN
            mfzShowInputBox("TestFZ", _
                            vbCr + _
                            "This is the test program. " + _
                            "You must put in a signature and a key. " + _
                            "A capital letter and a small letter are distinguished.", _
                            productKeySize, _
                            userName, _
                            produktKey)

            '// v_NgL[mFF؃R[h
            If (mfzGetValidationCode(produktKey.ToString(), userName.ToString(), validationCode) = MFZ_SUCCESS) Then
                ok = MFZ_YES
                putData = True
            End If
        End If



        '//
        '//// Ԓl
        '//
        Dim systemTime As MFZ_SYSTEMTIME = New MFZ_SYSTEMTIME
        Dim days As Integer
        Dim r1 As Integer, r2 As Integer

        '// Ԓl擾(userName ͕K{)
        If (getTime) Then
            r1 = mfzGetTime(userName.ToString(), time)
        End If

        r2 = mfzGetSystemTime(userName.ToString(), time, systemTime)

        If (r2 = MFZ_TMS_SUCCESS_AND_TIME_MADE) Then
            putData = True
        End If

        days = mfzGetTimeSpan(userName.ToString(), time)

        '//
        '//// gNt@C
        '//
        Dim r3 As Integer, r4 As Integer

        If (createTrunk) Then
            r3 = mfzCreateTrunk(trunkName.ToString(), MFZ_CTK_ATTRIBUTE_READONLY)
        End If

        '// Trunk file ɏ
        If (putData) Then
            r4 = mfzPutCode(trunkName.ToString(), validationCode, time, userName.ToString())
        End If

        '//
        '//// bZ[W
        '//
        Dim message As String
        Dim icon As MessageBoxIcon

        If (ok = MFZ_NO) Then

            message = String.Format("{0:d} days have passed since you set up this program. " + _
                                        " Put in the key, if you please." + _
                                        vbCr + _
                                        vbCr + _
                                        "User Name:{1:s}" + _
                                        vbCr + _
                                        "DATE:{2:d}/{3:d}/{4:d} {5:d}:{6:d}:{7:d}", _
                                        days, _
                                        userName, _
                                        systemTime.month, _
                                        systemTime.day, _
                                        systemTime.year, _
                                        systemTime.hour, _
                                        systemTime.minute, _
                                        systemTime.second)
            icon = MessageBoxIcon.Warning
        Else
            message = String.Format("Validation code is enabled for this program." + _
                                        vbCr + _
                                        vbCr + _
                                        "User Name:{1:s}" + _
                                        vbCr + _
                                        "Installation date : {2:d}/{3:d}/{4:d} {5:d}:{6:d}:{7:d}" + _
                                        "Time span : {0:d}", _
                                        days, _
                                        userName, _
                                        systemTime.month, _
                                        systemTime.day, _
                                        systemTime.year, _
                                        systemTime.hour, _
                                        systemTime.minute, _
                                        systemTime.second)
            icon = MessageBoxIcon.Information
        End If

        MessageBox.Show(message, "TestFZ", MessageBoxButtons.OK, icon)


        If ok = MFZ_YES Then
            Return True
        Else
            Return False
        End If

    End Function

    Private Function ExecuteStrategyD(ByVal command As String) As Boolean
        '//  F
        '//	`DhćAst@Cɓ
        '//	aDTrunk t@CgpBiF؃R[hgpj	
        '//
        '//	F
        '//	PDvONɃv_NgL[mF
        '//	QDF؃R[h́ATrunk t@Cɏ
        '//	RDNƂɔF؃R[hmF
        '//	
        '//	̃Tv͂̂܂܂ł͓삵܂BK؂ȂhcZbgĂB

        '/*	MANUFACUTURER: m.magic
        'PRODUCT NAME: TestFZ
        'STORING PLACE OF IDENTITY: Inside
        'INCLUDED HARDWARE: CPU
        'VSI: Ready
        'TOOL: Visual C++
        'MAGIC CODE(x86): 0xd87f80c8
        'MAGIC CODE(x64): 0xa883ad35
        'NOTES:  F؃R[hbot̂()

        'Product(Key)
        '  0	01BbOwYqUTzX01al
        '  1	01QR698qWGYhaGcX
        '  2	01SotPmXt1tE8uzI
        '  3	01YAFRk9LMDZnlt9*/

        '// Application Identity
        Dim id() As Byte = { _
        &H18, &H4C, &H6, &H71, &HBA, &H36, &H7B, &HE0, &HA3, &HE4, &H61, &HAA, &HA3, &HE4, &H61, &HAA, &H54, &H47, &H25, &H8B, _
        &HEA, &H44, &H2A, &HCA, &HFA, &HF5, &HE4, &H70, &H99, &H60, &HA7, &HA9, &H6F, &H91, &H99, &HF2, &H3E, &H1A, &HB6, &H69, _
        &HD2, &H48, &H1F, &H56, &HDD, &H40, &HD9, &HE1, &HAF, &H71, &HFF, &H34, &HB2, &HAA, &HC, &H7E, &H77, &HA0, &HE2, &H58, _
        &H3, &H6D, &HE1, &H25, &H25, &HD8, &HF9, &H1A, &H39, &HAA, &H80, &H17, &H1B, &H88, &H3E, &H3C, &H23, &HFA, &HC9, &H25, _
        &H3D, &HA3, &HBD, &H32, &H29, &H79, &H78, &H17, &H33, &H5E, &HC2, &H14, &H3, &H63, &HA1, &H25, &H15, &H5D, &HB1, &HA, _
        &H19, &H79, &HE0, &H37, &HB, &HED, &H16, &H2C, &H23, &H7, &H19, &H25, &H2D, &HC5, &HF5, &H22, &H29, &H5B, &HE8, &H37, _
        &H23, &H3D, &H9A, &H4, &H3, &HD9, &H61, &H25, &H5, &H59, &H69, &H3A, &H39, &H8A, &H40, &H17, &H3B, &H52, &H6E, &H1C, _
        &H23, &H85, &H49, &H25, &H1D, &HD0, &H2D, &H12, &H29, &H5F, &H58, &H17, &H13, &H39, &H72, &H34, &H3, &H96, &HE1, &H25, _
        &H35, &HCD, &HE1, &H2A, &H19, &H12, &HE0, &H37, &H2B, &HDE, &H86, &HC, &H23, &H47, &HB9, &H25, &HD, &HB7, &H65, &H2, _
        &H29, &HB9, &HA8, &H37, &H3, &HBF, &H4A, &H24, &H3, &HBF, &H61, &H25 _
        }

        '// ckk
        Dim ini As MFZ_INI_PARAMS_A = New MFZ_INI_PARAMS_A()

        ini.initialize()
        ini.functions = MFZ_INI_STANDARD Or MFZ_VALDATIONCODE_HDD_AND_CPU
        '//MFZ_INI_STANDARD//MFZ_INI_LEGACY//MFZ_INI_PRODUCTKEY_VERSION_40
        ini.size = MFZ_INI_PARAMS_A_SIZE
        id.CopyTo(ini.identity, 0)

        ShowConditions(command, 0, MFZ_NO, ini.functions And MFZ_VALDATIONCODE)

        If (mfzInitializeA(ini) <> MFZ_SUCCESS) Then
            Return False
        Else
            Return Verify()
        End If

    End Function


    Private Function ExecuteStrategyC(ByVal command As String) As Boolean
        '//  F
        '//	`DhćAst@Cɓ
        '//	aDTrunk t@CgpBiF؃R[hgpj	
        '//
        '//	F
        '//	PDvONɃv_NgL[mF
        '//	QDF؃R[h́ATrunk t@Cɏ
        '//	RDNƂɔF؃R[hmF
        '//	
        '//	̃Tv͂̂܂܂ł͓삵܂BK؂ȂhcZbgĂB

        '/*	MANUFACUTURER: m.magic
        'PRODUCT NAME: TestFZ
        'STORING PLACE OF IDENTITY: Inside
        'INCLUDED HARDWARE: CPU
        'VSI: Ready
        'TOOL: Visual C++
        'MAGIC CODE(x86): 0xd87f80c8
        'MAGIC CODE(x64): 0xa883ad35
        'NOTES: F؃R[hbot̂

        'Product Key
        '0	01BbOwYqUTzX01al
        '1	01QR698qWGYhaGcX
        '2	01SotPmXt1tE8uzI
        '3	01YAFRk9LMDZnlt9*/

        '// Application Identity
        Dim id() As Byte = { _
        &H18, &H4C, &H6, &H71, &HBA, &H36, &H7B, &HE0, &HA3, &HE4, &H61, &HAA, &HA3, &HE4, &H61, &HAA, &H54, &H47, &H25, &H8B, _
        &HEA, &H44, &H2A, &HCA, &HFA, &HF5, &HE4, &H70, &H99, &H60, &HA7, &HA9, &H6F, &H91, &H99, &HF2, &H3E, &H1A, &HB6, &H69, _
        &HD2, &H48, &H1F, &H56, &HDD, &H40, &HD9, &HE1, &HAF, &H71, &HFF, &H34, &HB2, &HAA, &HC, &H7E, &H77, &HA0, &HE2, &H58, _
        &H3, &H6D, &HE1, &H25, &H25, &HD8, &HF9, &H1A, &H39, &HAA, &H80, &H17, &H1B, &H88, &H3E, &H3C, &H23, &HFA, &HC9, &H25, _
        &H3D, &HA3, &HBD, &H32, &H29, &H79, &H78, &H17, &H33, &H5E, &HC2, &H14, &H3, &H63, &HA1, &H25, &H15, &H5D, &HB1, &HA, _
        &H19, &H79, &HE0, &H37, &HB, &HED, &H16, &H2C, &H23, &H7, &H19, &H25, &H2D, &HC5, &HF5, &H22, &H29, &H5B, &HE8, &H37, _
        &H23, &H3D, &H9A, &H4, &H3, &HD9, &H61, &H25, &H5, &H59, &H69, &H3A, &H39, &H8A, &H40, &H17, &H3B, &H52, &H6E, &H1C, _
        &H23, &H85, &H49, &H25, &H1D, &HD0, &H2D, &H12, &H29, &H5F, &H58, &H17, &H13, &H39, &H72, &H34, &H3, &H96, &HE1, &H25, _
        &H35, &HCD, &HE1, &H2A, &H19, &H12, &HE0, &H37, &H2B, &HDE, &H86, &HC, &H23, &H47, &HB9, &H25, &HD, &HB7, &H65, &H2, _
        &H29, &HB9, &HA8, &H37, &H3, &HBF, &H4A, &H24, &H3, &HBF, &H61, &H25 _
        }

        '// ckk
        Dim ini As New MFZ_INI_PARAMS_A

        ini.initialize()
        ini.functions = MFZ_INI_STANDARD
        '//MFZ_INI_STANDARD//MFZ_INI_LEGACY//MFZ_INI_PRODUCTKEY_VERSION_40
        ini.size = MFZ_INI_PARAMS_A_SIZE
        id.CopyTo(ini.identity, 0)


        ShowConditions(command, 0, MFZ_NO, ini.functions And MFZ_VALDATIONCODE)

        If (mfzInitializeA(ini) <> MFZ_SUCCESS) Then
            Return False
        Else
            Return Verify()
        End If

    End Function

    Private Function ExecuteStrategyB(ByVal command As String) As Boolean
        '//  F
        '//	`DhćAckk(Magiccodegp)ɓ
        '//	aDTrunk t@CgpBiF؃R[hgpj	
        '//
        '//	F
        '//	PDNɁAv_NgL[͂
        '//	QDF؃R[h Trunk t@Cɏ
        '//	RDȌANƂɔF؃R[hmF
        '//	
        '//	̃Tv͂̂܂܂ł͓삵܂BK؂ȂhcZbgĂB

        '/*	MANUFACUTURER: m.magic
        'PRODUCT NAME: TestFZ
        'STORING PLACE OF IDENTITY: Inside
        'INCLUDED HARDWARE: CPU
        'VSI: Ready
        'TOOL: Visual C++
        'MAGIC CODE(x86): 0xd87f80c8
        'MAGIC CODE(x64): 0xa883ad35
        'NOTES:  F؃R[hbot̂()

        '// Application Identity
        Dim id() As Byte = { _
        &H18, &H4C, &H6, &H71, &HBA, &H36, &H7B, &HE0, &HA3, &HE4, &H61, &HAA, &HA3, &HE4, &H61, &HAA, &H54, &H47, &H25, &H8B, _
        &HEA, &H44, &H2A, &HCA, &HFA, &HF5, &HE4, &H70, &H99, &H60, &HA7, &HA9, &H6F, &H91, &H99, &HF2, &H3E, &H1A, &HB6, &H69, _
        &HD2, &H48, &H1F, &H56, &HDD, &H40, &HD9, &HE1, &HAF, &H71, &HFF, &H34, &HB2, &HAA, &HC, &H7E, &H77, &HA0, &HE2, &H58, _
        &H3, &H6D, &HE1, &H25, &H25, &HD8, &HF9, &H1A, &H39, &HAA, &H80, &H17, &H1B, &H88, &H3E, &H3C, &H23, &HFA, &HC9, &H25, _
        &H3D, &HA3, &HBD, &H32, &H29, &H79, &H78, &H17, &H33, &H5E, &HC2, &H14, &H3, &H63, &HA1, &H25, &H15, &H5D, &HB1, &HA, _
        &H19, &H79, &HE0, &H37, &HB, &HED, &H16, &H2C, &H23, &H7, &H19, &H25, &H2D, &HC5, &HF5, &H22, &H29, &H5B, &HE8, &H37, _
        &H23, &H3D, &H9A, &H4, &H3, &HD9, &H61, &H25, &H5, &H59, &H69, &H3A, &H39, &H8A, &H40, &H17, &H3B, &H52, &H6E, &H1C, _
        &H23, &H85, &H49, &H25, &H1D, &HD0, &H2D, &H12, &H29, &H5F, &H58, &H17, &H13, &H39, &H72, &H34, &H3, &H96, &HE1, &H25, _
        &H35, &HCD, &HE1, &H2A, &H19, &H12, &HE0, &H37, &H2B, &HDE, &H86, &HC, &H23, &H47, &HB9, &H25, &HD, &HB7, &H65, &H2, _
        &H29, &HB9, &HA8, &H37, &H3, &HBF, &H4A, &H24, &H3, &HBF, &H61, &H25 _
        }

        'Product(Key)
        '   0	01BbOwYqUTzX01al
        '   1	01QR698qWGYhaGcX
        '   2	01SotPmXt1tE8uzI
        '   3	01YAFRk9LMDZnlt9*/

        '// ckk
        Dim ini As MFZ_INI_PARAMS_B = New MFZ_INI_PARAMS_B

        ini.initialize()
        ini.functions = MFZ_INI_STANDARD '//MFZ_INI_LEGACY//MFZ_INI_PRODUCTKEY_VERSION_40
        ini.size = MFZ_INI_PARAMS_B_SIZE
        '// K{II
#If AMD64 Then
	    ini.magicCode = &Ha883ad35
#Else
        ini.magicCode = &HD87F80C8
#End If

        ShowConditions(command, ini.magicCode, MFZ_NO, MFZ_VALDATIONCODE_CPU)

        If (mfzInitializeB(ini) <> MFZ_SUCCESS) Then
            Return False
        Else
            Return Verify()
        End If

    End Function

    Private Function ExecuteStrategyA(ByVal command As String) As Boolean
        '//  F
        '//	`DhćACXg[[ŎgpckkƎst@Cɓ
        '//	aDTrunk t@CgpBiF؃R[hgpj	
        '//
        '//	F
        '//	PDCXg[[ɂv_NgL[͔F؍ς
        '//	QDF؃R[h́ACXg[[ɂ菊 Trunk t@Cɏݍς
        '//	RDNƂɔF؃R[hmF
        '//	
        '//	̃Tv͂̂܂܂ł͓삵܂BK؂ȂhcZbgĂB

        '/*	MANUFACUTURER: m.magic
        'PRODUCT NAME: TestFZ
        'STORING PLACE OF IDENTITY: Inside
        'INCLUDED HARDWARE: CPU
        'VSI: Ready
        'TOOL: Visual C++
        'MAGIC CODE(x86): 0xd87f80c8
        'MAGIC CODE(x64): 0xa883ad35
        'NOTES:  F؃R[hbot̂()

        'Product(Key)
        '  0	01BbOwYqUTzX01al
        '  1	01QR698qWGYhaGcX
        '  2	01SotPmXt1tE8uzI
        '  3	01YAFRk9LMDZnlt9*/


        Dim id() As Byte = { _
        &H18, &H4C, &H6, &H71, &HBA, &H36, &H7B, &HE0, &HA3, &HE4, &H61, &HAA, &HA3, &HE4, &H61, &HAA, &H54, &H47, &H25, &H8B, _
        &HEA, &H44, &H2A, &HCA, &HFA, &HF5, &HE4, &H70, &H99, &H60, &HA7, &HA9, &H6F, &H91, &H99, &HF2, &H3E, &H1A, &HB6, &H69, _
        &HD2, &H48, &H1F, &H56, &HDD, &H40, &HD9, &HE1, &HAF, &H71, &HFF, &H34, &HB2, &HAA, &HC, &H7E, &H77, &HA0, &HE2, &H58, _
        &H3, &H6D, &HE1, &H25, &H25, &HD8, &HF9, &H1A, &H39, &HAA, &H80, &H17, &H1B, &H88, &H3E, &H3C, &H23, &HFA, &HC9, &H25, _
        &H3D, &HA3, &HBD, &H32, &H29, &H79, &H78, &H17, &H33, &H5E, &HC2, &H14, &H3, &H63, &HA1, &H25, &H15, &H5D, &HB1, &HA, _
        &H19, &H79, &HE0, &H37, &HB, &HED, &H16, &H2C, &H23, &H7, &H19, &H25, &H2D, &HC5, &HF5, &H22, &H29, &H5B, &HE8, &H37, _
        &H23, &H3D, &H9A, &H4, &H3, &HD9, &H61, &H25, &H5, &H59, &H69, &H3A, &H39, &H8A, &H40, &H17, &H3B, &H52, &H6E, &H1C, _
        &H23, &H85, &H49, &H25, &H1D, &HD0, &H2D, &H12, &H29, &H5F, &H58, &H17, &H13, &H39, &H72, &H34, &H3, &H96, &HE1, &H25, _
        &H35, &HCD, &HE1, &H2A, &H19, &H12, &HE0, &H37, &H2B, &HDE, &H86, &HC, &H23, &H47, &HB9, &H25, &HD, &HB7, &H65, &H2, _
        &H29, &HB9, &HA8, &H37, &H3, &HBF, &H4A, &H24, &H3, &HBF, &H61, &H25 _
        }

        '// ckk
        Dim ini As MFZ_INI_PARAMS_A = New MFZ_INI_PARAMS_A

        ini.initialize()
        ini.functions = MFZ_INI_STANDARD Or MFZ_VALDATIONCODE_CPU
        '//MFZ_INI_STANDARD//MFZ_INI_LEGACY//MFZ_INI_PRODUCTKEY_VERSION_40
        ini.size = MFZ_INI_PARAMS_A_SIZE
        id.CopyTo(ini.identity, 0)

        ShowConditions(command, 0, MFZ_YES, ini.functions And MFZ_VALDATIONCODE)

        If (mfzInitializeA(ini) <> MFZ_SUCCESS) Then
            Return False
        Else
            Return Verify()
        End If

    End Function

End Module
